<?php

/***************************************************************************
 *
 *   MOD                  : Atlas MOD
 *   file                 : admin/admin_atlas_mod.php
 *   copyright            : (C) 2005 Jonas Neubert
 *   web                  : www.jonemo.de
 *
 *		This script uses ideas and snippets from the file admin/admin_board.php
 *		which was written by the phpBB Group.
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
   $filename = basename(__FILE__);
   $module['General']['Atlas_Mod'] = $filename;

   return;
}

//
// Load default header
//
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx); 

//
// Is this the installation?
// If yes, we need to set up the databas
//

if (isset($HTTP_POST_VARS['submit']) && isset($HTTP_POST_VARS['install_key']) && isset($HTTP_POST_VARS['install_key_admin']) && !isset($board_config['atlas_google_api_key']) && !isset($board_config['atlas_google_api_key_admin']))
{
	if (!empty($HTTP_POST_VARS['install_key']) && !empty($HTTP_POST_VARS['install_key_admin']))
	{
			// do the database setup
		$sql = "ALTER TABLE " . USERS_TABLE . " ADD `user_long` FLOAT( 6 ) NOT NULL ,
 ADD `user_lat` FLOAT( 6 ) NOT NULL";
		$db->sql_query($sql);
		
		$sql = "INSERT INTO " . CONFIG_TABLE . " ( `config_name` , `config_value` )
				VALUES ('atlas_start_long', '15.5'),
 						('atlas_start_lat', '59'),
						('atlas_start_zoom', '14'),
						('atlas_width', '700'),
						('atlas_height', '490'),
						('atlas_start_map_type', '0'),
						('atlas_google_api_key', '" . str_replace("\'", "''", $HTTP_POST_VARS['install_key']) . "'),
						('atlas_google_api_key_admin', '" . str_replace("\'", "''", $HTTP_POST_VARS['install_key_admin']) . "'),
						('atlas_control_glmc', 1),
						('atlas_control_gsmc', 0),
						('atlas_control_gszc', 0),
						('atlas_control_gmtc', 1),
						('atlas_override_center_to_user', 0),
						('atlas_override_automode', 0),
						('atlas_distance_unit', 'km')";
		$db->sql_query($sql);
		
		if (isset($HTTP_POST_VARS['import_mapmod_users']))
		{
			$sql = "SELECT * FROM " . MAP_MOD_USER_TABLE;
			$res = $db->sql_query($sql);
			while ($row = $db->sql_fetchrow($res))
			{
				$sql = "UPDATE " . USERS_TABLE . " SET user_long = '" . $row['longitude'] . "', user_lat = '" . $row['latitude'] . "' WHERE user_id = " . $row['user_id'];
				echo $sql . '<br>';
				$db->sql_query($sql);
			}
		}
		
		$message = $lang['Atlas_mod_installed'] . "<br /><br />" . sprintf($lang['Click_return_atlasmod_config'], "<a href=\"" . append_sid("admin_atlas_mod.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
	else
	{
		$template->assign_vars(array(
			"S_INSTALL_KEY" => $HTTP_POST_VARS['install_key'],
			"S_INSTALL_KEY_ADMIN" => $HTTP_POST_VARS['install_key_admin'],
			"L_INSTALL_KEY_ERROR" => (empty($HTTP_POST_VARS['install_key'])) ? sprintf($lang['Atlas_Install_key_error'], $board_config['server_name'] . $board_config['script_path']) : '',
			"L_INSTALL_KEY_ADMIN_ERROR" => (empty($HTTP_POST_VARS['install_key_admin'])) ? sprintf($lang['Atlas_Install_key_error'], $board_config['server_name'] . $board_config['script_path'] . 'admin/') : '',
		));
	}
}


//
// Pull all config data
//
$sql = "SELECT * FROM " . CONFIG_TABLE . " WHERE config_name LIKE 'atlas_%'";
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not query config information in Atlas Mod Administration", "", __LINE__, __FILE__, $sql);
}
elseif ($db->sql_numrows($result) == 0)
{define('MAP_MOD_USER_TABLE', 'phpbb_map_mod_user');
	$template->assign_block_vars('switch_uninstalled', array());
	// determine if Mapmod by Bananeweizen is installed
	if (defined('MAP_MOD_USER_TABLE'))
	{
		$sql = "SELECT COUNT(*) AS a FROM " . MAP_MOD_USER_TABLE;
		$res = $db->sql_query($sql);
		$row = $db->sql_fetchrow($res);
		if (intval($row['a']) > 0)
		{
			$template->assign_block_vars('switch_uninstalled.switch_mapmod_import', array());
		}
	}
}
else
{
	$new = array();
	$row = array();
	
	while( $row = $db->sql_fetchrow($result) )
	{
		$new[$row['config_name']] = ( isset($HTTP_POST_VARS[$row['config_name']]) ) ? $HTTP_POST_VARS[$row['config_name']] : $row['config_value'];


		if( isset($HTTP_POST_VARS['submit']) )
		{
			$sql = "UPDATE " . CONFIG_TABLE . " SET
				config_value = '" . str_replace("\'", "''", $new[$row['config_name']]) . "'
				WHERE config_name = '" . $row['config_name'] . "'";
			
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Failed to update general configuration for $config_name", "", __LINE__, __FILE__, $sql);
			}
		}
	}

	if( isset($HTTP_POST_VARS['submit']) )
	{
		$message = $lang['Config_updated'] . "<br /><br />" . sprintf($lang['Click_return_atlasmod_config'], "<a href=\"" . append_sid("admin_atlas_mod.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
	
	$template->assign_block_vars('switch_installed', array());

	$atlas_control_glmc_yes = ( $new['atlas_control_glmc'] ) ? "checked=\"checked\"" : "";
	$atlas_control_glmc_no  = ( !$new['atlas_control_glmc'] ) ? "checked=\"checked\"" : "";
	$atlas_control_gsmc_yes = ( $new['atlas_control_gsmc'] ) ? "checked=\"checked\"" : "";
	$atlas_control_gsmc_no  = ( !$new['atlas_control_gsmc'] ) ? "checked=\"checked\"" : "";
	$atlas_control_gszc_yes = ( $new['atlas_control_gszc'] ) ? "checked=\"checked\"" : "";
	$atlas_control_gszc_no  = ( !$new['atlas_control_gszc'] ) ? "checked=\"checked\"" : "";
	$atlas_control_gmtc_yes = ( $new['atlas_control_gmtc'] ) ? "checked=\"checked\"" : "";
	$atlas_control_gmtc_no  = ( !$new['atlas_control_gmtc'] ) ? "checked=\"checked\"" : "";
	$atlas_override_ctu_yes  = ( $new['atlas_override_center_to_user'] ) ? "checked=\"checked\"" : "";
	$atlas_override_ctu_no  = ( !$new['atlas_override_center_to_user'] ) ? "checked=\"checked\"" : "";
	$atlas_override_automode_yes  = ( $new['atlas_override_automode'] ) ? "checked=\"checked\"" : "";
	$atlas_override_automode_no  = ( !$new['atlas_override_automode'] ) ? "checked=\"checked\"" : "";
	$distance_unit_km  = ( $new['atlas_distance_unit'] == 'km') ? "checked=\"checked\"" : "";
	$distance_unit_mi = ( $new['atlas_distance_unit'] == 'mi') ? "checked=\"checked\"" : "";	
}

$template->set_filenames(array(
	"body" => "admin/atlasmod_config_body.tpl")
);

if (!empty($new["atlas_google_api_key"]))
{
	$template->assign_block_vars('further_settings_on', array());
}

$template->assign_vars(array(
	"L_ATLAS_SETTINGS" => $lang['Atlas_Settings'],
	"L_SECTION_BASIC" => $lang['Atlas_Basic_Settings'],
	
	"L_CONFIGURATION_EXPLAIN" => $lang['Atlas_Settings_explain'],
	"L_INSTALLATION_EXPLAIN" => $lang['Atlas_Installation_explain'],
	"L_GOOGLE_API_KEY" => $lang['Atlas_google_api_key'],
	"L_GOOGLE_API_KEY_EXPLAIN" => sprintf($lang['Atlas_google_api_key_explain'], $board_config['server_name'] . $board_config['script_path']),
	"L_GOOGLE_API_KEY_EXPLAIN_INSTALL" => sprintf($lang['Atlas_Install_google_api_key_explain'], $board_config['server_name'] . $board_config['script_path']),
	"L_GOOGLE_API_KEY_ADMIN" => $lang['Atlas_google_api_key_admin'],
	"L_GOOGLE_API_KEY_ADMIN_EXPLAIN" => sprintf($lang['Atlas_google_api_key_admin_explain'], $board_config['server_name'] . $board_config['script_path']),	
	"L_GOOGLE_API_KEY_ADMIN_EXPLAIN_INSTALL" => sprintf($lang['Atlas_Install_google_api_key_admin_explain'], $board_config['server_name'] . $board_config['script_path']),	
	"L_ATLAS_SIZE" => $lang['Atlas_size'],
	"L_ATLAS_SIZE_EXPLAIN" => $lang['Atlas_size_explain'],
	"L_GMAP_FINDCOORDS_EXPLAIN" => $lang['Atlas_find_coordinates_admin_explain'],
	"L_GMAP_FIND_COORDINATES" => $lang['Atlas_find_coordinates'],
	"U_GMAP_FIND_COORDINATES" => append_sid($phpbb_root_path . 'gmap.' . $phpEx . '?mode=findcoords'),
	"L_GMAP_CONTROLS" => $lang['Atlas_controls'],
	"L_GMAP_CONTROLS_EXPLAIN" => $lang['Atlas_controls_explain'],
	"L_GMAP_GLMC" => $lang['Atlas_control_glmc'],
	"L_GMAP_GSMC" => $lang['Atlas_control_gsmc'],
	"L_GMAP_GSZC" => $lang['Atlas_control_gszc'],
	"L_GMAP_GMTC" => $lang['Atlas_control_gmtc'],
	"L_OVERRIDE_INIT" => $lang['Atlas_Initial_Settings'],
	"L_OVERRIDE_INIT_EXPLAIN" => $lang['Atlas_Initial_Settings_Explain'],
	"L_OVERRIDE_CENTER_TO_USER" => $lang['Atlas_Override_init_zoom_to_user'],
	"L_OVERRIDE_CENTER_TO_USER_EXPLAIN" => $lang['Atlas_Override_init_zoom_to_user_explain'],
	"L_OVERRIDE_AUTOMODE" => $lang['Atlas_Override_init_to_auto'],
	"L_OVERRIDE_AUTOMODE_EXPLAIN" => $lang['Atlas_Override_init_to_auto_explain'],
	"L_SUBMIT" => $lang['Submit'], 
	"L_RESET" => $lang['Reset'],
	"L_YES" => $lang['Yes'],
	"L_NO" => $lang['No'],
	"L_ENABLED" => $lang['Enabled'],
	"L_DISABLED" => $lang['Disabled'],	
	"L_DISTANCE_UNIT" => $lang['Atlas_distance_unit'],
	"L_KM" => $lang['Atlas_km'],
	"L_MI" => $lang['Atlas_mi'],
	"L_INSTALL" => $lang['Atlas_Installation'],
	"L_IMPORT_MAPMOD_USERS" => $lang['Atlas_Import_mapmod_users'],
	"L_IMPORT_MAPMOD_USERS_EXPLAIN" => $lang['Atlas_Import_mapmod_users_explain'],	
	
	"GOOGLE_API_KEY_ADMIN" => $new['atlas_google_api_key_admin'],
	"GOOGLE_API_KE" => $new['atlas_google_api_key'],
	"MAP_WIDTH" => $new['atlas_width'],
	"MAP_HEIGHT" => $new['atlas_height'],
	"START_LONG" => $new['atlas_start_long'],
	"START_LAT" => $new['atlas_start_lat'],
	"START_ZOOM" => $new['atlas_start_zoom'],
	"START_MODE" => $new['atlas_start_map_type'],
	"S_GMAP_GLMC_YES" => $atlas_control_glmc_yes,
	"S_GMAP_GLMC_NO" => $atlas_control_glmc_no,
	"S_GMAP_GSMC_YES" => $atlas_control_gsmc_yes,
	"S_GMAP_GSMC_NO" => $atlas_control_gsmc_no,
	"S_GMAP_GSZC_YES" => $atlas_control_gszc_yes,
	"S_GMAP_GSZC_NO" => $atlas_control_gszc_no,
	"S_GMAP_GMTC_YES" => $atlas_control_gmtc_yes,
	"S_GMAP_GMTC_NO" => $atlas_control_gmtc_no,
	"S_GMAP_OVERRIDE_CTU_YES" => $atlas_override_ctu_yes,
	"S_GMAP_OVERRIDE_CTU_NO" => $atlas_override_ctu_no,
	"S_GMAP_OVERRIDE_AUTOMODE_YES" => $atlas_override_automode_yes,
	"S_GMAP_OVERRIDE_AUTOMODE_NO" => $atlas_override_automode_no,
	"S_DISTANCE_UNIT_KM" => $distance_unit_km,
	"S_DISTANCE_UNIT_MI" => $distance_unit_mi,	
));

if ($new['atlas_override_automode'] == 1)
{
	$sql = "SELECT MIN(user_long) AS min_long, MAX(user_long) AS max_long, MIN(user_lat) AS min_lat, MAX(user_lat) AS max_lat 
				FROM " . USERS_TABLE . " 
				WHERE user_long != '' AND user_lat != ''";

	$erg = $db->sql_query($sql);
	$limits = $db->sql_fetchrow($erg);
	
	$start_long	= $limits['min_long'] + ( $limits['max_long'] - $limits['min_long'] ) / 2;
	$start_lat	= $limits['min_lat'] + ( $limits['max_lat'] - $limits['min_lat'] ) / 2;	
	$start_zoom_level = 'auto';
}
// atlas_override_ctu is no option here, because that only applies, if users have a coordinate set what cannot be assumed as standard
else
{
	$start_long = $new['atlas_start_long'];
	$start_lat = $new['atlas_start_lat'];
	$start_zoom_level = $new['atlas_start_zoom'];
}

include ($phpbb_root_path . "includes/atlas_functions." . $phpEx);
make_atlasmod_js (4, $start_long, $start_lat, $start_zoom_level, $limits, NULL);

$template->pparse("body");

include('./page_footer_admin.'.$phpEx);

?>