<?php
/***************************************************************************
 *
 *   MOD                  : Atlas MOD
 *   file                 : gmap.php
 *   copyright            : (C) 2005 Jonas Neubert
 *   web                  : www.jonemo.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.' . $phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_GMAP);
init_userprefs($userdata);
//
// End session management
//

//
// Start Determining what page type has to be shown
//

// (mode="xml") means that this file is called via XmlHttpRequest from a JavaScript
if ($HTTP_GET_VARS['mode'] == 'xml')
{
	include($phpbb_root_path . 'includes/atlas_xml.php');
	die();
}

// all other modes than "xml" mean that a page will be shown to the user that contains a map of some sort
define('SHOW_ONLINE', true);
$page_title = $lang['GMap'];
include($phpbb_root_path . 'includes/atlas_functions.' . $phpEx);

// (mode="findcoords") is shown in a popup, therefore we show a simple header
if ($HTTP_GET_VARS['mode'] === 'findcoords')
	$gen_simple_header = true;

include($phpbb_root_path . 'includes/page_header.'.$phpEx);

// no matter which mode, all have the same template
$template->set_filenames(array(
    'body' => 'atlas_view.tpl')
);

//
// End Determining what page type has to be shown
//



if (!isset($board_config['atlas_google_api_key']))
{
	message_die(GENERAL_ERROR, sprintf($lang['AtlasError_not_finished_install']));
}
else
{
	$template->assign_block_vars('atlasmod', array());
	$template->assign_block_vars('switch_installed', array());
	
	// (mode="findcoords") means that no users are shown in the map but the map is used to find
	// the coordinates of a place and maybe also to set the zoom level and map type and so
	// "findcoords" is either called from a user editing his/her profile or from the
	// general board configuration where the admin wants to set the initial values for the map
	if ($HTTP_GET_VARS['mode'] === 'findcoords')
	{
		$l_map_title = $lang['GMap_find_coordinates'];
		$l_explain = $lang['GMap_find_coordinates_explain'];
		
		$modus = 3;
	}
	
	// (mode="viewmap") means that the page where all users are shown in a map is displayed
	elseif ($HTTP_GET_VARS['mode'] === 'viewmap' && $userdata["session_logged_in"])
	{
		$modus = 1;
	}
	
	// (mode="distance") means that the distance to another user is to be shown
	elseif ($HTTP_GET_VARS['mode'] == 'distance' && $userdata["session_logged_in"])
	{
		if (is_numeric($HTTP_GET_VARS['u']))
		{
			$sql = "SELECT user_id, username, user_long, user_lat FROM " . USERS_TABLE . " WHERE user_id = '" . $HTTP_GET_VARS['u'] . "'";
			$erg = $db->sql_query($sql);
			$row = $db->sql_fetchrowset($erg);
	
			$distance_parameters['lon'] = $row[0]['user_long'];
			$distance_parameters['lat'] = $row[0]['user_lat'];
			$distance_parameters['pid'] = $row[0]['user_id'];
			$distance_parameters['username'] = $row[0]['username'];
			
			$start_long = ( $row[0]['user_long'] + $userdata['user_long'] ) / 2;
			$start_lat = ( $row[0]['user_lat'] + $userdata['user_lat'] ) / 2;
			
			$modus = 2;
		}
	}
	
	// this comes into action when an anonymous user wants to do anything else than set his coordinates (during registration)
	else
	{
		$l_explain = $lang['GMap_Please_log_in'];
		$modus = -1;
	}
	
	// where to center the map at the beginning
	if (empty($start_long) || empty($start_lat))
	{
		if ($board_config['atlas_override_center_to_user'] == 1)
		{
			$start_long = $userdata['user_long'];
			$start_lat = $userdata['user_lat'];
		}
		elseif ($board_config['atlas_override_automode'] == 1)
		{
			$sql = "SELECT MIN(user_long) AS min_long, MAX(user_long) AS max_long, MIN(user_lat) AS min_lat, MAX(user_lat) AS max_lat FROM " . USERS_TABLE . " WHERE user_long != '' AND user_lat != ''";
			$erg = $db->sql_query($sql);
			$limits = $db->sql_fetchrow($erg);
			
			$start_long	= $limits['min_long'] + ( $limits['max_long'] - $limits['min_long'] ) / 2;
			$start_lat	= $limits['min_lat'] + ( $limits['max_lat'] - $limits['min_lat'] ) / 2;
			$start_zoom_level = 'auto';
		}
		else
		{
			$start_long = $board_config['atlas_start_long'];
			$start_lat = $board_config['atlas_start_lat'];
		}
	}
	
	//
	// Most of the settings and stuff is general (for all modes) and is done here:
	//
	
	/*
		possible modi for calling this page are:
			1 => view the map with all usercoordinates
			2 => view the distance to another user
			3 => "find coordinates"
			4 => adminpanel
	*/
	
	make_atlasmod_js ($modus, $start_long, $start_lat, $start_zoom_level, $limits, $distance_parameters);
	
	$template->assign_vars(array(
		'MAP_WIDTH' => intval($board_config['atlas_width']) . 'px',
		'MAP_HEIGHT' => intval($board_config['atlas_height']) . 'px',
		'L_MAP_TITLE' => ( empty($l_map_title) ) ? $lang['GMap'] : $l_map_title,
		'L_EXPLAIN' => ( empty($l_explain) ) ? '' : $l_explain
	));
}

//
// Generate the page
//
$template->pparse('body');
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>