<?
/***************************************************************************
 *
 *   MOD                  : Atlas MOD
 *   file                 : includes/gmap_xml.php
 *   copyright            : (C) 2005 Jonas Neubert
 *   web                  : www.jonemo.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if (!defined('IN_PHPBB'))
{
	die('Hacking attempt');
}

include_once($phpbb_root_path . 'includes/atlas_functions.php');

// this is required - if it is not here, the file will not be recognized by the javascript
header('Content-type: text/xml');

// this encoding needs to be set, otherwise IE will go on strike as soon as something non-ascii arrives
echo '<?xml version="1.0" encoding="ISO-8859-1" ?>';
echo '<r>';

if ( !is_numeric($HTTP_GET_VARS['minx']) || !is_numeric($HTTP_GET_VARS['miny']) || !is_numeric($HTTP_GET_VARS['maxx']) || !is_numeric($HTTP_GET_VARS['maxy']) )
{
	echo '<error>' . $lang['AtlasError_wrong_xml_parameter'] . '</error>';
}
else
{
	$width = abs($HTTP_GET_VARS['maxx'] - $HTTP_GET_VARS['minx']);
	$height = abs($HTTP_GET_VARS['maxy'] - $HTTP_GET_VARS['miny']);
	$pixelwidth = $width / (1.8 * $board_config['atlas_width']);
	$pixelheight = $height / (1.8 * $board_config['atlas_height']);
   $criticaldistance = sqrt(pow(15 * $pixelwidth,2) + pow(15 * $pixelheight, 2));	// the distance in ltdlng where points would intersect each other

	// get some statistical information on the distribution of the points
	$sql = "SELECT AVG(user_long) AS average_long, AVG(user_lat) AS average_lat FROM " . USERS_TABLE . " WHERE user_long > " . floatval($HTTP_GET_VARS['minx']) . " AND user_long < " . floatval($HTTP_GET_VARS['maxx']) . " AND user_lat > " . floatval($HTTP_GET_VARS['miny']) . " AND user_lat < " . floatval($HTTP_GET_VARS['maxy']) . " AND user_long != 0 AND user_lat != 0";
	$erg = $db->sql_query($sql);
	$row = $db->sql_fetchrow($erg);
	$average_long = $row['average_long'];
	$average_lat = $row['average_lat'];
	// gives the averages of the two values

	$sql = "SELECT STD(SQRT(POW(" . $average_long . " - user_long, 2) + POW(" . $average_lat . " - user_lat, 2))) AS standart_deviation FROM " . USERS_TABLE . " WHERE user_long > " . floatval($HTTP_GET_VARS['minx']) . " AND user_long < " . floatval($HTTP_GET_VARS['maxx']) . " AND user_lat > " . floatval($HTTP_GET_VARS['miny']) . " AND user_lat < " . floatval($HTTP_GET_VARS['maxy']) . " AND user_long != 0 AND user_lat != 0";
	$erg = $db->sql_query($sql);
	$row2 = $db->sql_fetchrow($erg);
	$standart_deviation = $row2['standart_deviation'];
	// gives the standart_deviation

	$sql = "SELECT COUNT(*) AS users_in_critical_radius FROM " . USERS_TABLE . " WHERE SQRT( POW(user_long - " . $average_long . ", 2) + POW(user_lat - " . $average_lat . ", 2) ) < " . $criticaldistance;
	$erg = $db->sql_query($sql);
	$row3 = $db->sql_fetchrow($erg);
	$users_in_critical_radius = $row3['users_in_critical_radius'];
	// how many users are within a critical distance of the average values?

	// ehrm, well, yes. couldn't think of a better way of doing the following
	// the next versions will see a much better implementation of the "do something 
	// against users being too near each other" problem (yes, that's a promise)
/*	if ($row3['e'] > get_db_stat('usercount') * 0.05 )
	{
		if (20 * $pixelwidth > 0.01)
		{
			$rounder = 1;
		}
		elseif (20 * $pixelwidth > 0.001)
		{
			$rounder = 3;
		}
		elseif (20 * $pixelwidth > 0.0001)
		{
			$rounder = 4;
		}
		elseif (20 * $pixelwidth > 0.00001)
		{
			$rounder = 4;
		}
		elseif (20 * $pixelwidth > 0.000001)
		{
			$rounder = 5;
		}
		else
		{
			$rounder = 8;
		}
	}
	else
		$rounder = 8;
*/	
	// fix
	$rounder = 8;

	// we include a certain amount of area that is not actually shown on the map to give the user the illusion that all users are shown all over the world. 
	$sql = "SELECT ROUND(user_long, " . $rounder . ") AS longitude, ROUND(user_lat, " . $rounder . ") AS latitude, user_long, user_lat, username, user_id, user_avatar, user_avatar_type FROM " . USERS_TABLE . " WHERE user_long > " . floatval($HTTP_GET_VARS['minx']) . " AND user_long < " . floatval($HTTP_GET_VARS['maxx']) . " AND user_lat > " . floatval($HTTP_GET_VARS['miny']) . " AND user_lat < " . floatval($HTTP_GET_VARS['maxy']) . " AND user_long != 0 AND user_lat != 0 ORDER BY longitude ASC, latitude ASC";

	$erg = $db->sql_query($sql);
	$num = $db->sql_numrows($erg);

	$lastone = array('long' => 'none', 'lat' => 'none');

	while ($row = $db->sql_fetchrow($erg))
	{
		$distance = ($userdata['session_logged_in'] == 1) ? calculate_distance($userdata['user_long'], $userdata['user_lat'], $row['user_long'], $row['user_lat']) : '';
		if ($row['longitude'] != $lastone['long'] || $row['latitude'] != $lastone['lat'])
		{
			if ($lastone['long'] != 'none')
			{
				echo '</m>';
			}
		
			echo '<m lng="' . $row['longitude'] . '" ltd="' . $row['latitude'] . '">';
		}
		// Get the avatar
		$avatar = '';
		switch( $row['user_avatar_type'] )
		{
			case USER_AVATAR_UPLOAD:
				$avatar = $board_config['avatar_path'] . '/' . $row['user_avatar'];
				break;
			case USER_AVATAR_REMOTE:
				$avatar = $row['user_avatar'];
				break;
			case USER_AVATAR_GALLERY:
				$avatar = $board_config['avatar_gallery_path'] . '/' . $row['user_avatar'];
				break;
		}
		
		// Get avatars width and height for javascript
		// Without this the info window looks ugly!
		list($awidth, $aheight, $atype, $aattr) = getimagesize($avatar);
		echo '<u id="' . $row['user_id'] . '" dist="' . $distance . '" img="' . $avatar . '" x="' . $awidth . '" y="' . $aheight . '">' . $row['username'] . '</u>';

		$lastone['long'] = $row['longitude'];
		$lastone['lat'] = $row['latitude'];
	}

	if ($lastone['long'] != 'none')
	{
		echo '</m>';
	}
}

echo '<debug>';
echo '<criticaldistance>' . $criticaldistance . '</criticaldistance>';
echo '<average_long>' . $average_long . '</average_long>';
echo '<average_lat>' . $average_lat . '</average_lat>';
echo '<standart_deviation>' . $standart_deviation . '</standart_deviation>';
echo '<rounder>' . $rounder . '</rounder>';
echo '<users_in_critical_radius>' . $users_in_critical_radius . '</users_in_critical_radius>';
echo '</debug>';
echo '</r>';

?>